#pragma once

class Grid
{
private:
	int m_iCountX;
	int m_iCountY;
	char* m_achCell;

public:
	Grid()
	{
		m_iCountX = 0;
		m_iCountY = 0;
		m_achCell = NULL;
	}

	~Grid()
	{
		if( NULL != m_achCell ){ delete m_achCell; }
		m_achCell = NULL;
	}

	int GetCountX() const
	{
		return m_iCountX;
	}

	int GetCountY() const
	{
		return m_iCountY;
	}

	void Init( int iCountX, int iCountY )
	{
		if( NULL != m_achCell ){ delete m_achCell; }
		m_iCountX = iCountX;
		m_iCountY = iCountY;
		m_achCell = new char[m_iCountX * m_iCountY];
	}

	char GetCell( int iIndexX, int iIndexY ) const
	{
		if( 0 > iIndexX
			|| ( m_iCountX - 1 ) < iIndexX
			|| 0 > iIndexY
			|| ( m_iCountY - 1 ) < iIndexY )
		{
			return '\0';
		}

		return m_achCell[iIndexX + iIndexY * m_iCountX];
	}

	void SetCell( int iIndexX, int iIndexY, char value )
	{
		if( 0 > iIndexX
			|| ( m_iCountX - 1 ) < iIndexX
			|| 0 > iIndexY
			|| ( m_iCountY - 1 ) < iIndexY )
		{
			return;
		}

		m_achCell[iIndexX + iIndexY * m_iCountX] = value;
	}
};

