//
// ImprovedGemsScanLineSeefFill.cpp
//
// ̈hׂ
// @Graphics Gems I ̎ASỶǔ
// 
// Written by Nobuki HIRAMINE
// Last modified : 2018/02/18
//

#include <assert.h>	// for assert()
#include "Grid.h"	// for CGrid

#define MAX_STACK_COUNT (10000)

struct Segment
{
	int iY;
	int iXL;
	int iXR;
	int iDeltaY;
};

// X^bNɃZOg̒ǉ
static void PushSegment( Segment* aSegmentStack, int& riCountSegment, int iY, int iXL, int iXR, int iDeltaY, int iGridHeight )
{
	assert( riCountSegment < MAX_STACK_COUNT );
	if( iY < 0
		|| iY > iGridHeight - 1 )
	{	// Obh͈͊O
		return;
	}
	aSegmentStack[riCountSegment].iY = iY;
	aSegmentStack[riCountSegment].iXL = iXL;
	aSegmentStack[riCountSegment].iXR = iXR;
	aSegmentStack[riCountSegment].iDeltaY = iDeltaY;
	// ZOg₷B
	riCountSegment++;
}

// X^bNZOg̎o
static void PopSegment( Segment* aSegmentStack, int& riCountSegment, int& riY, int& riXL, int& riXR, int& riDeltaY )
{
	// ZOgP炷B
	riCountSegment--;
	riY = aSegmentStack[riCountSegment].iY;
	riXL = aSegmentStack[riCountSegment].iXL;
	riXR = aSegmentStack[riCountSegment].iXR;
	riDeltaY = aSegmentStack[riCountSegment].iDeltaY;
}

void ImprovedGemsScanLineSeedFill( Grid& rGrid, const int iSeedX, const int iSeedY, const char chNew )
{
	if( 0 > iSeedX
		|| rGrid.GetCountX() - 1 < iSeedX
		|| 0 > iSeedY
		|| rGrid.GetCountY() - 1 < iSeedY )
	{	// Obh͈͊ÓAhׂsv
		return;
	}

	// X^bN
	Segment aSegmentStack[MAX_STACK_COUNT];
	int iCountSegment = 0;

	// hׂΏېF
	char chOld = rGrid.GetCell( iSeedX, iSeedY );

	if( chOld == chNew )
	{	// Ώۂ̃ZɐVFȂ΁AhׂsvB
		return;
	}

	// V[hZAZOgX^bNɓo^B
	// utɂāAwZOg͈͂́Ahׂς݁xAwZOg͈͂̍E̗אڂPŹAhׂΏۂłȂxvOƂĂ邪A
	// V[hZ̃ZOgX^bNo^ɂẮȂO͐藧ȂB
	// uV[hZ̃ZOgX^bNo^́AQsvƂƁA
	// uV[hZ̃ZOgX^bNo^̂Pڂ́AV[hZ̍E܂߂RZōsvƂőΏB
	if( chOld == rGrid.GetCell( iSeedX, iSeedY + 1 ) )
	{	// +ÝAY+1̃ZhׂΏۂ̏ꍇ̂ݓo^
		PushSegment( aSegmentStack, iCountSegment, iSeedY + 1, iSeedX - 1 >= 0 ? iSeedX - 1 : iSeedX, iSeedX + 1 < rGrid.GetCountX() ? iSeedX + 1 : iSeedX, 1, rGrid.GetCountY() );
	}
	PushSegment( aSegmentStack, iCountSegment, iSeedY, iSeedX, iSeedX, -1, rGrid.GetCountY() );

	while( iCountSegment > 0 )
	{
		// ZOgo
		int iSegmentY;
		int iSegmentXL;
		int iSegmentXR;
		int iSegmentDeltaY;
		PopSegment( aSegmentStack, iCountSegment, iSegmentY, iSegmentXL, iSegmentXR, iSegmentDeltaY );

		// iSegmentXL 獶hׂ
		int x = iSegmentXL;
		while( x >= 0 )
		{
			if( chOld != rGrid.GetCell( x, iSegmentY ) )
			{	// hׂΏۈȊO獶ThׂIB
				break;
			}
			rGrid.SetCell( x, iSegmentY, chNew );
			x--;
		}

		int iStartX;	// hׂsꂽ[ʒu
		if( x == iSegmentXL )
		{	// hׂsĂȂ̂ŁA[ʒuƂāAȒlݒ肵Ă
			iStartX = -1;
		}
		else
		{
			// whileŁACfbNXs߂ĂihΏۈȊOwĂĵŁA߂B
			iStartX = x + 1;

			if( iStartX < iSegmentXL - 1 )
			{	// ZOg͈͊O̓hׂsꂽꍇ́AtŃZOgo^
				PushSegment( aSegmentStack, iCountSegment, iSegmentY - iSegmentDeltaY, iStartX, iSegmentXL - 2, -iSegmentDeltaY, rGrid.GetCountY() );
			}

			// iSegmentXL 獶hׂɑāAiSegmentXL + 1 Ehׂ
			x = iSegmentXL + 1;
		}

		// Ehׂ
		do
		{
			if( -1 != iStartX )
			{
				// hׂΏۊO܂
				while( x <= rGrid.GetCountX() )
				{
					if( chOld != rGrid.GetCell( x, iSegmentY ) )
					{	// hׂΏۈȊOɒH蒅甲
						break;
					}
					rGrid.SetCell( x, iSegmentY, chNew );
					x++;
				}

				// hׂ͈͂AŃZOgo^
				PushSegment( aSegmentStack, iCountSegment, iSegmentY + iSegmentDeltaY, iStartX, x - 1, iSegmentDeltaY, rGrid.GetCountY() );
				if( x - 1 > iSegmentXR + 1 )
				{	// ZOg͈͊O̓hׂsꂽꍇ́AtŃZOgo^
					PushSegment( aSegmentStack, iCountSegment, iSegmentY - iSegmentDeltaY, iSegmentXR + 2, x - 1, -iSegmentDeltaY, rGrid.GetCountY() );
				}
				iStartX = -1;	// [ʒuƂāAȒlݒ
			}

			// Vȍ[ʒuT
			x++;
			while( x <= iSegmentXR )
			{
				if( chOld == rGrid.GetCell( x, iSegmentY ) )
				{	// hׂΏۂ甲
					rGrid.SetCell( x, iSegmentY, chNew );
					iStartX = x;
					x++;
					break;
				}
				x++;
			}
		} while( -1 != iStartX );
	}
}

