//
// ScanLineSeefFill.cpp
//
// ̈hׂ
// @Scan Line Seed Fill ASY
// 
// Written by Nobuki HIRAMINE
// Last modified : 2018/02/18
//

#include <assert.h>	// for assert()
#include "Grid.h"	// for CGrid

#define MAX_STACK_COUNT (10000)

struct Segment
{
	int iY;
	int iXL;
	int iXR;
};

// X^bNɃZOg̒ǉ
static void PushSegment( Segment* aSegmentStack, int& riCountSegment, int iY, int iXL, int iXR, int iGridHeight )
{
	assert( riCountSegment < MAX_STACK_COUNT);
	if( iY < 0
	 || iY > iGridHeight - 1 )
	{	// Obh͈͊O
		return;
	}
	aSegmentStack[riCountSegment].iY = iY;
	aSegmentStack[riCountSegment].iXL = iXL;
	aSegmentStack[riCountSegment].iXR = iXR;
	// ZOg₷B
	riCountSegment++;
}

// X^bNZOg̎o
static void PopSegment( Segment* aSegmentStack, int& riCountSegment, int& riY, int& riXL, int& riXR )
{
	// ZOgP炷B
	riCountSegment--;
	riY = aSegmentStack[riCountSegment].iY;
	riXL = aSegmentStack[riCountSegment].iXL;
	riXR = aSegmentStack[riCountSegment].iXR;
}

void ScanLineSeedFill( Grid& rGrid, const int iSeedX, const int iSeedY, const char chNew )
{
	if( 0 > iSeedX
		|| rGrid.GetCountX() - 1 < iSeedX
		|| 0 > iSeedY
		|| rGrid.GetCountY() - 1 < iSeedY )
	{	// Obh͈͊ÓAhׂsv
		return;
	}

	// X^bN
	Segment aSegmentStack[MAX_STACK_COUNT];
	int iCountSegment = 0;

	// hׂΏېF
	char chOld = rGrid.GetCell( iSeedX, iSeedY );

	if( chOld == chNew )
	{	// Ώۂ̃ZɐVFȂ΁AhׂsvB
		return;
	}

	// V[hZAZOgX^bNɓo^B
	PushSegment( aSegmentStack, iCountSegment, iSeedY, iSeedX, iSeedX, rGrid.GetCountY() );

	while( iCountSegment > 0 )
	{
		// ZOgo
		int iSegmentY;
		int iSegmentXL;
		int iSegmentXR;
		PopSegment( aSegmentStack, iCountSegment, iSegmentY, iSegmentXL, iSegmentXR );

		// iSegmentXL 獶hׂ
		int x = iSegmentXL;
		while( x >= 0 )
		{
			if( chOld != rGrid.GetCell( x, iSegmentY ) )
			{	// hׂΏۈȊO獶ThׂIB
				break;
			}
			rGrid.SetCell( x, iSegmentY, chNew );
			x--;
		}

		int iStartX;	// hׂsꂽ[ʒu
		if( x == iSegmentXL )
		{	// hׂsĂȂ̂ŁA[ʒuƂāAȒlݒ肵Ă
			iStartX = -1;
		}
		else
		{
			// whileŁACfbNXs߂ĂihΏۈȊOwĂĵŁA߂B
			iStartX = x + 1;
			x = iSegmentXL + 1;
		}

		// Ehׂ
		do
		{
			if( -1 != iStartX )
			{
				while( x <= rGrid.GetCountX() )
				{
					if( chOld != rGrid.GetCell( x, iSegmentY ) )
					{	// hׂΏۈȊOɒH蒅甲
						break;
					}
					rGrid.SetCell( x, iSegmentY, chNew );
					x++;
				}

				// hׂ͈͂ɂāwPs͈̔́xwPs͈̔́xZOgX^bNɓo^B
				PushSegment( aSegmentStack, iCountSegment, iSegmentY + 1, iStartX, x - 1, rGrid.GetCountY() );
				PushSegment( aSegmentStack, iCountSegment, iSegmentY - 1, iStartX, x - 1, rGrid.GetCountY() );
			}
			x++;
			while( x <= iSegmentXR )
			{
				if( chOld == rGrid.GetCell( x, iSegmentY ) )
				{	// hׂΏۂ甲
					break;
				}
				x++;
			}
			iStartX = x;
		} while( x <= iSegmentXR );
	}
}
