// SeedFillTest.cpp : R\[ AvP[ṼGg |Cg`܂B
//

#include "stdafx.h"

#include <conio.h>	// _getch()
#include <string.h>

#include "Grid.h"

// Seed Fill ֐̃vg^Cv錾
void SeedFill( Grid& rGrid, const int iSeedX, const int iSeedY, const char chNew );
void ScanLineSeedFill( Grid& rGrid, const int iSeedX, const int iSeedY, const char chNew );
void GemsScanLineSeedFill( Grid& rGrid, const int iSeedX, const int iSeedY, const char chNew );
void ImprovedGemsScanLineSeedFill( Grid& rGrid, const int iSeedX, const int iSeedY, const char chNew );

// Obh̍\z
bool InitGrid( Grid& rGrid, char* pchCell )
{
	int iSizeCell = strlen( pchCell );

	int iGridWidth = rGrid.GetCountX();
	int iGridHeight = rGrid.GetCountY();
	int iSizeGrid = iGridWidth * iGridHeight;

	if( iSizeCell != iSizeGrid )
	{
		return false;
	}

	int iCounter = 0;
	for( int y = 0; y < iGridHeight; y++ )
	{
		for( int x = 0; x < iGridWidth; x++ )
		{
			rGrid.SetCell( x, y, pchCell[iCounter] );
			iCounter++;
		}
	}

	return true;
}

// R\[`
void Render( Grid& rGrid )
{
	int iGridWidth = rGrid.GetCountX();
	int iGridHeight = rGrid.GetCountY();
	for( int y = 0; y < iGridHeight; y++ )
	{
		for( int x = 0; x < iGridWidth; x++ )
		{
			printf( "%c", rGrid.GetCell( x, y ) );
		}
		printf( "\n" );
	}
	printf( "\n" );
}

int main()
{
	char* aachCell[10];

	// Tv̈
	aachCell[0] = \
		"        "\
		" ###### "\
		" #    # "\
		" # #  # "\
		"  # ##  "\
		"        ";

	aachCell[1] = \
		"            "\
		"     ####   "\
		"   ##    #  "\
		" ##      #  "\
		" #      #   "\
		" #  #  #    "\
		"  ## ##     "\
		"            "\
		"            ";

	aachCell[2] = \
		"                          "\
		"          ##    ######    "\
		"         # ######    #    "\
		"     ## #          ###    "\
		"   ##  ##  ###### ###     "\
		"  #    ## #     #   #     "\
		"  #   # #  ###  ###  #    "\
		" #   ## #     #    #  #   "\
		" #     ## ##   #    # #   "\
		"  ##      # #   #   # #   "\
		"    #    ## #    #  # #   "\
		"   #    #   #   #   # #   "\
		"  #      ###   #    # #   "\
		"  # ###       #   ### ### "\
		"  #  ##  #  ##   ## # # # "\
		"   ## #  ## #   # #     # "\
		"      ###  ##  #  ### # # "\
		"              #         # "\
		"              ########### "\
		"                          ";

	// ObhTṽ[v
	for( int iGridSample = 0; iGridSample < 3; iGridSample++ )
	{
		Grid grid;
		switch( iGridSample )
		{
			case 0:
				grid.Init( 8, 6 );	// for 1
				break;
			case 1:
				grid.Init( 12, 9 );	// for 2
				break;
			case 2:
				grid.Init( 26, 20 );	// for 3
				break;
		}

		// Obh\z
		if( !InitGrid( grid, aachCell[iGridSample] ) )
		{
			printf( "Failed : InitGrid()\n" );
			printf( "Hit any key." );
			_getch();
			return 0;
		}

		// hׂO̕`
		printf( "Before Fill\n");
		Render( grid );

		// hׂASỸ[v
		for( int iAlgo = 0; iAlgo < 4; iAlgo++ )
		{
			// Obh̍č\z
			InitGrid( grid, aachCell[iGridSample] );

			// hׂ֐|C^
			void (*Fill)( Grid& rGrid, const int iSeedX, const int iSeedY, const char chNew );

			switch( iAlgo )
			{
				case 0:
					Fill = SeedFill;
					printf( "SeedFill\n");
					break;
				case 1:
					Fill = ScanLineSeedFill;
					printf( "ScanLineSeedFill\n");
					break;
				case 2:
					Fill = GemsScanLineSeedFill;
					printf( "GemsScanLineSeedFill\n");
					break;
				case 3:
					Fill = ImprovedGemsScanLineSeedFill;
					printf( "ImprovedGemsScanLineSeedFill\n");
					break;
			}

			// V[h_ʒúAObhTvƂɐݒ
			switch( iGridSample )
			{
				case 0:
					Fill( grid, 4, 3, '+' );
					break;
				case 1:
					Fill( grid, 4, 4, '+' );
					break;
				case 2:
					Fill( grid, 3, 7, '+');
					break;
			}

			// hׂ̕`
			Render( grid );
		}
	}

	printf( "Hit any key." );
	_getch();
	return 0;
}

